#include <iostream>
#include <cmath>
using namespace std;
void evklid(int a,int b,int &x1,int &y1)
{
     x1=1; y1=0;
     int x2=0,y2=1,q,t,r;
     while(b!=0)
     {
                r=a%b; q=a/b;
                a=b; b=r;
                
                t=x2;
                x2=x1-q*x2;
                x1=t;
                
                t=y2;
                y2=y1-q*y2;
                y1=t;
     }
}
int main()
{
    int a,b,s;
    cin >> a >> b >> s;
    int d=__gcd(a,b);
    if(s%d!=0) { cout << "NO SOLUTION\n"; return 0; }
    a/=d; b/=d; s/=d;
    int x1,y1;
    evklid(a,b,x1,y1);
    
    x1*=s; y1*=s;
    long long x,y,mn;
    int mnx,mny;
    mnx=x1; mny=y1;
    mn=abs(x1)*a*d+abs(y1)*b*d;
    
    for(int k=-s;k<=s;k++)
    {
            x=x1+k*b;
            y=y1-k*a;
            //cout << x << " " << y << endl;
            if(abs(x)*a*d+abs(y)*b*d<mn) { mnx=x; mny=y; mn=abs(x)*a*d+abs(y)*b*d; }
            else if(abs(x)*a*d+abs(y)*b*d==mn && abs(x)+abs(y)<abs(mnx)+abs(mny))
                 { mnx=x; mny=y; mn=abs(x)*a*d+abs(y)*b*d; }
    }
    //cout << endl;
    cout << abs(mnx)+abs(mny) << endl << mn << endl;
    if(mnx>0)
    {
             for(int i=0;i<mnx;i++) cout << "+1\n";
             if(mny<0) for(int i=0;i<abs(mny);i++) cout << "-2\n";
             else for(int i=0;i<mny;i++) cout << "+2\n";
    }
    else
    {
        for(int i=0;i<mny;i++) cout << "+2\n";
        for(int i=0;i<abs(mnx);i++) cout << "-1\n";
    }
    return 0;
}
